<template>
    <v-menu
        v-model="isMenuOpened"
        :close-on-content-click="false"
        transition="scale-transition"
        offset-y
        max-width="290px"
        min-width="290px"
    >
        <template v-slot:activator="{ on, attrs }">
            <v-text-field
                v-model="computedDateFormatted"
                prepend-icon="mdi-calendar"
                readonly
                v-bind="attrs"
                v-on="on"
            ></v-text-field>
        </template>
        <v-date-picker
            :value="value"
            @input="onDatePick"
            :events="this.events"
            :min="this.min"
            :max="this.max"
            :disabled="disabled"
        ></v-date-picker>
    </v-menu>
</template>

<script>
export default {
    props: ['value', 'events', 'min', 'max', 'disabled'],
    data() {
        return {
            isMenuOpened: false
        }
    },

    created() {
        
    },

    computed: {
        computedDateFormatted() {
            return this.formatDate(this.value);
        },
    },

    watch: {
    },

    methods: {
        formatDate(date) {
            if (!date) return null;

            const [year, month, day] = date.split("-");
            return `${day}/${month}/${year}`;
        },
        parseDate(date) {
            if (!date) return null;

            const [day, month, year] = date.split("/");
            return `${year}-${month.padStart(2, "0")}-${day.padStart(2, "0")}`;
        },
        onDatePick(value) {
            this.isMenuOpened = false;
            this.$emit('input', value);
        }
    }
};
</script>
